<template lang="pug">
div
  .z-max
    .column.justify-center.full-height
      .voting
        div
          .q-px-sm {{ heading }}
          .q-px-sm.text-subtitle1(v-if="message") {{ message }}
          ul(v-if="!selectedVotingItemName")
            li.text-subtitle1(v-for="item in topVotingItems") {{ item }}
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";
import { defaultSubmissionName, VotingPluginConfig, VotingPluginMeeting } from "zoomsense-plugin-voting-common";

import { areVotesRatings, getVoteTypeName, getVotingItemData } from "./votingUtils";

export default Vue.extend({
  name: "Overlay",

  props: {
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    context: {
      required: false,
      type: Object as PropType<{ meetingid: string }>,
    },
  },

  data() {
    return {
      meetingVotes: null as null | VotingPluginMeeting,
      votingConfig: null as null | VotingPluginConfig,
    };
  },

  computed: {
    voteTypeName(): undefined | { singular: string; plural: string } {
      return getVoteTypeName(this.votingConfig ?? undefined);
    },

    voteTypeNameSingularCapitalised(): string | undefined {
      const itemName = this.voteTypeName?.singular;
      if (itemName === undefined) {
        return undefined;
      }
      return itemName.substring(0, 1).toUpperCase() + itemName.substring(1);
    },

    selectedVotingItemName(): string | null {
      return this.meetingVotes?.items?.[this.meetingVotes.currentItem!]?.item.itemName ?? null;
    },

    topVotingItems(): string[] {
      if (this.meetingVotes === null) {
        return [];
      }
      return getVotingItemData(this.meetingVotes)
        .filter(({ voteTotals }) => Object.keys(voteTotals).length > 0)
        .sort(({ score: score1 }, { score: score2 }) => +score2 - +score1)
        .map(({ itemName, score }) => `${score}: ${itemName}`)
        .slice(0, this.meetingVotes.numOverlayItems ?? 5);
    },

    heading(): string | null {
      const topItemCount = this.topVotingItems.length;
      return this.selectedVotingItemName
        ? `${this.voteTypeNameSingularCapitalised}: ${this.selectedVotingItemName}`
        : topItemCount > 1
        ? `Top ${topItemCount} ${this.voteTypeName?.plural}`
        : topItemCount === 1
        ? `Top ${this.voteTypeName?.singular}`
        : null;
    },

    message(): string | null {
      if (!this.selectedVotingItemName || !this.votingConfig) {
        return null;
      }
      const ratingType = areVotesRatings(this.votingConfig);
      return ratingType
        ? `Type a single number from 1 to 5 in the chat to rate this ${this.voteTypeName?.singular}.`
        : `Type "y" or "yes" in the chat (without quotes) if you think it is a good ${this.voteTypeName?.singular}, or "n" or "no" (without quotes) if you think it is not that important.`;
    },
  },

  async created() {
    await this.$typedRtdbBind(
      "votingConfig",
      this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/voting`)
    );
  },

  watch: {
    votingConfig: {
      immediate: true,
      async handler() {
        const submissionName = this.votingConfig?.submissionName ?? defaultSubmissionName;
        await this.$typedRtdbBind(
          "meetingVotes",
          this.firebase.ref(`data/plugins/voting/${this.context.meetingid}/${submissionName}`)
        );
      },
    },
  },
});
</script>

<style lang="scss" scoped>
.voting {
  display: flex;
  background: rgb(1, 77, 109);
  color: white;
  border-radius: 5px;
  box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.3), 0 6px 20px 0 rgba(0, 0, 0, 0.5);
  font-size: 26px;
  overflow: hidden;
  height: 250px;
  width: 550px;
  align-items: center;
  transform: perspective(1500px) rotateY(15deg);
}

.z-max {
  position: absolute;
  height: 720px;
  width: 480px;
  z-index: -3;
  left: 10px;
}
</style>
